<template>
    <div class="form_login_container">
        <!--  STEP 1  -->
        <div class="space_between" v-if="step === 1">
            <div>
                <div class="titles">
                    <div class="block-title active">{{$t('message.enter_cabinet_title')}}</div>
                    <router-link to="/register" class="block-title" exact>{{$t('message.registration')}}</router-link>
                </div>

                <form @submit.prevent="login" style='width: 100%'>
                    <div class="input_container" style="display:block;">
                        <div class="fix-margin">
                            <v-text-field
                                name="phone"
                                type="text"
                                :placeholder="$t('message.phone_placeholder')"
                                :class="[error ? 'error' : '']"
                                v-mask="mask"
                                @input="error = ''"
                                @focus="initMask"
                                v-model='phone'
                                template='<input>'
                            ></v-text-field>
                        </div>

                        <div v-if="error" class="message error">
                            <template v-if="error && error.phone">{{this.error.phone[0]}}</template>
                        </div>
                    </div>

                    <div class="input_container second">
                        <div class="fix-margin">
                            <input
                                v-model='password'
                                type="password"
                                :placeholder="$t('message.password_placeholder')"
                                :class="[error ? 'error' : '']"
                                @input="error = ''"
                                @keyup.enter="login"
                            >
                            <!--                        <div class="lbl">{{$t('message.password_placeholder')}}</div>-->
                        </div>
                    </div>
                </form>

                <div v-if="error" class="message error">
                    <template v-if="error && error.password">{{this.error.password[0]}}</template>
                </div>

                <router-link to="/reset" class="forgot_password">{{$t('message.forgot_password')}}</router-link>
                <!--            {{error}}-->
                <div v-if="error" class="message error">
                    <template v-if="error.common">{{this.error.common}}</template>
                </div>
            </div>

            <div class="buttons">
                <button @click="login" :disabled="isLoading" class="btn enter">{{$t('message.enter')}}</button>
            </div>

            <mobile-app-links/>
        </div>

        <!--  STEP 2  -->
        <div class="space_between" v-if="step === 2">
            <div>
                <!--                TODO position of return btn-->
                <a @click.prevent="stepBack()" class="back_arrow">
                    <svg width="44" height="35" viewBox="0 0 44 35" fill="none" xmlns="http://www.w3.org/2000/svg">
                        <g>
                            <rect x="16.9712" y="0.712891" width="2" height="23.3212"
                                  transform="rotate(45 16.9712 0.712891)"/>
                            <rect y="17.707" width="2" height="23.9822" transform="rotate(-45 0 17.707)"/>
                            <rect x="2.37598" y="18.7617" width="2" height="41"
                                  transform="rotate(-90 2.37598 18.7617)"/>
                        </g>
                    </svg>
                </a>
                <div class="titles two_rows">
                    <div class="block-title active">{{$t('message.registration')}}</div>
                </div>

                <div class="input_container second">
                    <button type='button' class="change_phone" @click="stepBack()">{{$t('message.change_phone')}}</button>

                    <div class="input_component fix-margin">
                        <input
                            id='code'
                            type='text'
                            v-model='code'
                            :placeholder="$t('message.check_your_phone')"
                            :class="[codeError ? 'error' : '']"
                            @input="codeError = ''"
                            @keyup.enter="validateCode"
                            autocomplete="off"
                        >
                        <div class="lbl">{{$t('message.check_your_phone')}}</div>
                    </div>
                </div>
                <div class="message">{{$t('message.sent_sms')+phone}}</div>

                <div v-if="codeError" class="message error">{{ codeError }}</div>

                <div v-if="timeout" @click='sendCodeToPhone' class="message">
                    <span class="link">{{$t('message.code_again')}}</span>
                </div>
            </div>
            <div class="buttons">
                <button @click='validateCode' type='submit' class="btn enter">{{$t('message.continue')}}</button>
            </div>
        </div>

        <!--  STEP 3  -->
        <div class="space_between" v-if="step === 3">
            <div>
                <div class="titles">
                    <div class="block-title active">{{$t('message.password_create')}}</div>
                </div>
                <a @click="stepBack()" class="back_arrow">
                    <svg width="44" height="35" viewBox="0 0 44 35" fill="none" xmlns="http://www.w3.org/2000/svg">
                        <g>
                            <rect x="16.9712" y="0.712891" width="2" height="23.3212"
                                  transform="rotate(45 16.9712 0.712891)"/>
                            <rect y="17.707" width="2" height="23.9822" transform="rotate(-45 0 17.707)"/>
                            <rect x="2.37598" y="18.7617" width="2" height="41"
                                  transform="rotate(-90 2.37598 18.7617)"/>
                        </g>
                    </svg>
                </a>

                <div class="input_container">
                    <div class="input_component fix-margin">
                        <input
                            id='password'
                            type='password'
                            v-model='password'
                            v-bind:placeholder="$t('message.create_password')"
                            :class="(password_errors.password || password_errors.c_password) ? 'error' : ''"
                            @keyup.enter="register"
                        >
                        <div class="lbl">{{$t('message.create_password')}}</div>
                    </div>
                </div>
                <div class="input_container second">
                    <div class="input_component fix-margin">
                        <input
                            id='c_password'
                            type='password'
                            v-model='c_password'
                            :placeholder="$t('message.confirm_password')"
                            :class="(password_errors.password || password_errors.c_password) ? 'error' : ''"
                            @keyup.enter="register"
                        >
                        <div class="lbl">{{$t('message.confirm_password')}}</div>
                    </div>
                </div>

                <label class="checkbox_group" :class='confirm_agreement ? "active" :  ""'>
                    <span class="radio"></span>
                    <span class="text">
                        {{$t('message.agreement_message')}} <a href="https://"
                                                               target="_blank">{{$t('message.agreement_link_message')}}</a>
                    </span>
                    <input type="checkbox" v-model="confirm_agreement">
                </label>

                <div
                    v-if="registration_error"
                    class="message error">
                    {{registration_error}}
                </div>
            </div>

            <div class="buttons">
                <button
                    :disabled='!confirm_agreement'
                    @click='register'
                    type='submit'
                    class="btn enter"
                >{{$t('message.continue')}}
                </button>
            </div>
        </div>
        <div v-if="isLoading" class="animation-container">
            <lottie :options="defaultOptions" :height="100" :width="100"/>
        </div>
    </div>
</template>

<script>
    import MobileAppLinks from './MobileAppLinks';
    import {mask} from 'vue-the-mask';
    import Lottie from 'vue-lottie';
    import * as animationData from "./animation/preload.json";

    export default {
        directives: {
            mask
        },
        components: {
            'lottie': Lottie,
            MobileAppLinks
        },
        data: () => ({
            password: '',
            c_password: '',
            code: '',
            error: '',
            codeError: '',
            mask: '+38 (0##) ###-##-##',
            step: 1,
            timeout: false,
            confirm_agreement: false,
            isLoading: false,
            defaultOptions: {animationData: animationData.default},
        }),
        computed: {
            phone: {
                set: function (n) {
                    this.$store.dispatch('set_phone', n)
                },
                get: function () {
                    return this.$store.getters.phone
                }
            },
            password_errors: function () {
                return this.$store.getters.password_errors;
            },
            registration_error: function () {
                if (this.password_errors.password)
                    return this.password_errors.password[0];
                else if (this.password_errors.c_password)
                    return this.password_errors.c_password[0];
                else if (this.password_errors.confirm_agreement)
                    return this.password_errors.confirm_agreement[0];
                else false
            },
        },
        methods: {
            async login() {
                try {
                    this.isLoading = true;
                    const {data} = await axios.post('/login', {
                        phone: this.phone,
                        password: this.password
                    });
                    if (data.is_valid) {
                        this.$router.push('/main');
                    } else {
                        // если номер телефона не найден и нужно регистрировать пользователя
                        if (data.registration === 1) {
                            this.step++;
                            await this.sendCodeToPhone();
                        } else {
                            await this.$store.dispatch('set_phone', this.phone);
                            this.error = data[0];
                        }
                    }
                } catch (e) {
                    // console.log(e);
                }
                this.isLoading = false;
            },
            async sendCodeToPhone() {
                try {
                    const {data} = await axios.post('/register/set_phone', {phone: this.phone});
                    if (!data.is_valid) {
                        this.codeError = data[0].phone[0];
                    }
                } catch (e) {
                    // console.log(e);
                }
                this.timeout = false;
                setTimeout(() => {
                    this.timeout = true;
                }, 30000);
            },
            async validateCode() {
                try {
                    const {data} = await axios.post('/register/validate_code', {
                        code: this.code,
                        phone: this.phone
                    });

                    if (!data.is_valid) {
                        this.codeError = this.$t('message.code_error');
                    } else {
                        this.step++;
                    }
                } catch (e) {
                    // console.log(e);
                }
            },
            async register() {
                try {
                    const {data} = await axios.post('/register', {
                        password: this.password,
                        c_password: this.c_password,
                        confirm_agreement: this.confirm_agreement
                    });

                    if (data[0]) {
                        this.$store.commit('set_password_err', data[0])
                    } else {
                        this.$router.push('/profile')
                    }
                    this.$store.commit('set_password_status', data.is_valid);

                } catch (e) {
                    // console.log(e);
                }
            },
            stepBack() {
                if (this.step > 1) {
                    this.step--;
                }
            },
            initMask() {
                this.phone = this.phone.length < 6 ? '+38 (0' : this.phone;
            }
        },
        created(){
            window.sessionStorage.clear();

            const seo = {
                title: 'Авторизуйтеся, щоб мати доступ до свого профілю ',
                description: 'Зайдіть до свого особистого кабінету',
                keywords: 'Авторизація, авторизуватися',
                h1: 'Авторизація'
            }
            document.title = seo.title;
            document.querySelector('head meta[name="description"]').setAttribute('content', seo.description);
            document.querySelector('head meta[name="keywords"]').setAttribute('content', seo.keywords);
            this.$emit('set-h1', seo.h1);
        }
    }
</script>

